#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "Test.h"

//  
const TCHAR szAppName[] = TEXT("MyMobileRobotHostProgram");
HINSTANCE hInst;
HWND hStatusEdit;

// IR ſ   

// #define IR_SHARED

#define IRCMD_LEFT_TURN				1
#define IRCMD_UP					2
#define IRCMD_RIGHT_TURN			3
#define IRCMD_DOWN					4
#define IRCMD_STOP					5
#define IRCMD_VELOCITY_UP			6
#define IRCMD_VELOCITY_DOWN			7
#define IRCMD_EYES					8

const TCHAR szIRComm[] = TEXT("COM2:");
HANDLE hIRComm = INVALID_HANDLE_VALUE;


// Message dispatch table for MainWidnowProc
const struct decodeUINT MainMessages[] = {
	WM_CREATE,		DoCreateMain,
	WM_COMMAND,		DoCommandMain,
	WM_PAINT,		DoPaintMain,
	WM_HIBERNATE,	DoHibernateMain,
	WM_ACTIVATE,	DoActivateMain,
	WM_DESTROY,		DoDestroyMain,
};

// α׷ 
int WINAPI WinMain(HINSTANCE hInstance, 
				   HINSTANCE hPrevInstance, 
				   LPWSTR lpCmdLine, 
				   int nCmdShow)
{
	MSG msg;
	int rc = 0;
	HWND hwndMain;

	//  α׷ ʱȭ
	rc = InitApp(hInstance);
	if(rc) return rc;

	// νϽ ʱȭ
	hwndMain = InitInstance(hInstance, lpCmdLine, nCmdShow);
	if(hwndMain == 0) return 0x10;

	//  α׷ ޽ 
	while(GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	// νϽ Ұ
	return TermInstance(hInstance, msg.wParam);
}

//  α׷ ʱȭ
int InitApp(HINSTANCE hInstance)
{
	WNDCLASS wc;

	// Pocket PC  ϳ νϽ ǰ 
#if defined(WIN32_PLATFORM_PSPC)
	HWND hWnd = FindWindow(szAppName, NULL);
	if(hWnd) {
		SetForegroundWindow((HWND)(((DWORD)hWnd) | 0x01));
		return -1;
	}
#endif

	//  α׷   
	wc.style			= 0;
	wc.lpfnWndProc		= MainWndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hInstance;
	wc.hIcon			= NULL;
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName		= NULL;
	wc.lpszClassName	= szAppName;

	if(RegisterClass(&wc) == 0)
		return 1;

	return 0;
}

// νϽ ʱȭ
HWND InitInstance(HINSTANCE hInstance, 
				  LPWSTR lpCmdLIne, 
				  int nCmdShow)
{
	HWND hWnd;

	// α׷ νϽ ڵ   
	hInst = hInstance;

	//   
	hWnd = CreateWindow(szAppName,				//  Ŭ
						TEXT("My Mobile Robot!"),	//  ŸƲ
						WS_VISIBLE,				// Ÿ ÷
						CW_USEDEFAULT,			// x ǥ
						CW_USEDEFAULT,			// y ǥ
						CW_USEDEFAULT,			// ʱ ʺ
						CW_USEDEFAULT,			// ʱ 
						NULL,					// θ
						NULL,					// ޴ (NULL )
						hInstance,				//  α׷ νϽ
						NULL);					//  Ű 

	if(!IsWindow(hWnd))
		return 0;

	// ǥ  ǥ/ 
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	
	return hWnd;
}

// α׷ Ұ
int TermInstance(HINSTANCE hInstance, 
				 int nDefRC)
{
	return nDefRC;
}

//  α׷ 츦  ݹ Լ
LRESULT CALLBACK MainWndProc(HWND hWnd, 
							 UINT wMsg, 
							 WPARAM wParam, 
							 LPARAM lParam)
{
	unsigned int i;

	for(i=0; i<dim(MainMessages); i++) {
		if(wMsg == MainMessages[i].Code)
			return (*MainMessages[i].Fxn)(hWnd, wMsg, wParam, lParam);
	}

	return DefWindowProc(hWnd, wMsg,wParam, lParam);
}

// WM_CREATE ޼ ó
LRESULT DoCreateMain(HWND hWnd, 
					 UINT wMsg, 
					 WPARAM wParam, 
					 LPARAM lParam)
{
	HWND hwndCB;
	HMENU hMainMenu, hPopupMenu;

	// Ŀǵ 
	hwndCB = CommandBar_Create(hInst, hWnd, IDC_CMDBAR);

	// ޴ ߰Ѵ
	hMainMenu = CreateMenu();

	// IR Comm ޴
	hPopupMenu = CreatePopupMenu();
	AppendMenu(hPopupMenu, MF_STRING | MF_ENABLED, MENU_GET_INFO,		TEXT("Get Info.."));
	AppendMenu(hPopupMenu, MF_SEPARATOR, 0, NULL);
	AppendMenu(hPopupMenu, MF_STRING | MF_ENABLED, MENU_OPEN_IR,		TEXT("Open IR.."));
	AppendMenu(hPopupMenu, MF_STRING | MF_ENABLED, MENU_CLOSE_IR,		TEXT("Close IR.."));
	AppendMenu(hMainMenu,  MF_STRING | MF_ENABLED | MF_POPUP, (UINT)hPopupMenu, TEXT("&IR Comm"));

	// Clear ޴
	AppendMenu(hMainMenu, MF_STRING | MF_ENABLED, (UINT)MENU_EDIT_CLEAR,	TEXT("&Clear"));

	CommandBar_InsertMenubarEx(hwndCB, NULL, (LPTSTR)hMainMenu, 0);

	// Ŀǵٿ   ߰
	CommandBar_AddAdornments(hwndCB, 0, 0);

	// ư ߰Ѵ.
	CreateWindow(TEXT("button"), TEXT("L-TURN!"), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				 20, 220+CommandBar_Height(hwndCB), BTN_WIDTH, BTN_HEIGHT, 
				 hWnd, (HMENU)BTN_LEFT_TURN, hInst, NULL);
	CreateWindow(TEXT("button"), TEXT("UP!"), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				 90, 170+CommandBar_Height(hwndCB), BTN_WIDTH, BTN_HEIGHT, 
				 hWnd, (HMENU)BTN_UP, hInst, NULL);
	CreateWindow(TEXT("button"), TEXT("R-TURN!"), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				 160, 220+CommandBar_Height(hwndCB), BTN_WIDTH, BTN_HEIGHT, 
				 hWnd, (HMENU)BTN_RIGHT_TURN, hInst, NULL);
	CreateWindow(TEXT("button"), TEXT("DOWN!"), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				 90, 220+CommandBar_Height(hwndCB), BTN_WIDTH, BTN_HEIGHT, 
				 hWnd, (HMENU)BTN_DOWN, hInst, NULL);

	CreateWindow(TEXT("button"), TEXT("V-UP"), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				 5, 160+CommandBar_Height(hwndCB), BTN_WIDTH-20, BTN_HEIGHT-20, 
				 hWnd, (HMENU)BTN_VELOCITY_UP, hInst, NULL);
	CreateWindow(TEXT("button"), TEXT("V-DN"), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				 5, 185+CommandBar_Height(hwndCB), BTN_WIDTH-20, BTN_HEIGHT-20, 
				 hWnd, (HMENU)BTN_VELOCITY_DOWN, hInst, NULL);

	CreateWindow(TEXT("button"), TEXT("STOP"), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				 195, 160+CommandBar_Height(hwndCB), BTN_WIDTH-20, BTN_HEIGHT-20, 
				 hWnd, (HMENU)BTN_STOP, hInst, NULL);
	CreateWindow(TEXT("button"), TEXT("Eyes"), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				 195, 185+CommandBar_Height(hwndCB), BTN_WIDTH-20, BTN_HEIGHT-20, 
				 hWnd, (HMENU)BTN_EYES, hInst, NULL);

	//  ڽ ߰Ѵ.
	hStatusEdit = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER | ES_LEFT |
							   ES_MULTILINE | ES_NOHIDESEL | ES_AUTOHSCROLL | ES_AUTOVSCROLL,
							   5, 5+CommandBar_Height(hwndCB), 230, 150, 
							   hWnd, (HMENU)STATUS_EDITBOX, hInst, NULL);


	return 0;
}

// WM_COMMAND ޼ ó
LRESULT DoCommandMain(HWND hWnd,
					  UINT wMsg,
					  WPARAM wParam,
					  LPARAM lParam)
{
	WORD wID, wNotifyCode;

	// ʱȭ
	wID = LOWORD(wParam);
	wNotifyCode = HIWORD(wParam);

	// decoding...
	switch(wID)
	{

		// ޴ ó
	case MENU_GET_INFO:
		MessageBox(hWnd, TEXT("My Mobile Robot Host Program v1.0"), TEXT("Info..."), MB_OK);
		break;

	case MENU_OPEN_IR:
		UserOpenIR(hWnd);
		break;

	case MENU_CLOSE_IR:
		UserCloseIR(hWnd);
		break;

	case MENU_EDIT_CLEAR:
		SetWindowText(hStatusEdit, TEXT(""));
		break;

		// ư ó
	case BTN_LEFT_TURN:
		UserSendData(hWnd, IRCMD_LEFT_TURN);
		break;

	case BTN_UP:
		UserSendData(hWnd, IRCMD_UP);
		break;

	case BTN_RIGHT_TURN:
		UserSendData(hWnd, IRCMD_RIGHT_TURN);
		break;

	case BTN_DOWN:
		UserSendData(hWnd, IRCMD_DOWN);
		break;

	case BTN_VELOCITY_UP:
		UserSendData(hWnd, IRCMD_VELOCITY_UP);
		break;

	case BTN_VELOCITY_DOWN:
		UserSendData(hWnd, IRCMD_VELOCITY_DOWN);
		break;

	case BTN_STOP:
		UserSendData(hWnd, IRCMD_STOP);
		break;

	case BTN_EYES:
		UserSendData(hWnd, IRCMD_EYES);
		break;
	}

	return 0;

}

// WM_PAINT ޼ ó
LRESULT DoPaintMain(HWND hWnd, 
					UINT wMsg, 
					WPARAM wParam, 
					LPARAM lParam)
{
	PAINTSTRUCT ps;
	RECT rect;
	HDC hdc;

	// Ŀǵ ̸ Ͽ Ŭ̾Ʈ  ũ 
	GetClientRect(hWnd, &rect);
	rect.top += CommandBar_Height(GetDlgItem(hWnd, IDC_CMDBAR));

	// ȭ鿡 α׷  ǥ
	hdc = BeginPaint(hWnd, &ps);
	{
		//
		// -- ⿡ Paint  Է
		//

	}
	EndPaint(hWnd, &ps);

	return 0;
}

// WM_HIBERNATE ޼ ó
LRESULT DoHibernateMain(HWND hWnd, 
						UINT wMsg, 
						WPARAM wParam, 
						LPARAM lParam)
{
	// Ȱ 찡 ƴ϶ Ŀǵٸ Ͽ ޸ 
	if(GetActiveWindow() != hWnd)
		CommandBar_Destroy(GetDlgItem(hWnd, IDC_CMDBAR));

	return 0;
}

// WM_ACTIVATE ޼ ó
LRESULT DoActivateMain(HWND hWnd, 
					   UINT wMsg, 
					   WPARAM wParam, 
					   LPARAM lParam)
{
	HWND hwndCB;

	// Ȱȭ Ǿµ Ŀǵ ٰ ٸ  
	if((LOWORD(wParam) != WA_INACTIVE) && (GetDlgItem(hWnd, IDC_CMDBAR) == 0)) {
		// Ŀǵ 
		hwndCB = CommandBar_Create(hInst, hWnd, IDC_CMDBAR);

		// Ŀǵٿ   ߰
		CommandBar_AddAdornments(hwndCB, 0, 0);
	}

	return 0;
}

// WM_DESTROY ޼ ó
LRESULT DoDestroyMain(HWND hWnd, 
					  UINT wMsg, 
					  WPARAM wParam, 
					  LPARAM lParam)
{
	PostQuitMessage(0);

	return 0;
}

// IR Comm Port Openϴ Լ
void UserOpenIR(HWND hWnd)
{
	DCB IRdcb;
	COMMTIMEOUTS IRcto;
	extern HANDLE hIRComm;

	// IR Ʈ   ݴ´.
	if(hIRComm != INVALID_HANDLE_VALUE)
	{
		UserCloseIR(hWnd);
	}

	// IR Ʈ Ѵ.
	hIRComm = CreateFile(szIRComm,
						 GENERIC_WRITE,
						 0,
						 NULL,
						 OPEN_EXISTING,
						 0,
						 NULL);

	// ߴٸ IR Ʈ ..
	if(hIRComm != INVALID_HANDLE_VALUE)
	{
		// SET Comm State...
		GetCommState(hIRComm, &IRdcb);
		{
			IRdcb.BaudRate	 = CBR_9600;
			IRdcb.ByteSize	 = 8;
			IRdcb.fParity	 = FALSE;
			IRdcb.fNull		 = FALSE;
			IRdcb.StopBits	 = ONESTOPBIT;
			IRdcb.Parity	 = NOPARITY;
		}
		SetCommState(hIRComm, &IRdcb);

		// SET Timeouts
		{
			IRcto.ReadIntervalTimeout			= 0;
			IRcto.ReadTotalTimeoutConstant		= 0;
			IRcto.ReadTotalTimeoutMultiplier	= 0;
			IRcto.WriteTotalTimeoutConstant		= 0;
			IRcto.WriteTotalTimeoutMultiplier	= 0;
		}
		SetCommTimeouts(hIRComm, &IRcto);

		// SET IR Share mode
#if defined(IR_SHARED)
		if(!EscapeCommFunction(hIRComm, SETIR))
		{
			SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
						(LPARAM)(LPCTSTR)TEXT("Set IR Failed..\r\n"));

			UserCloseIR(hWnd);
			return;
		}
#endif

		// Purge Comm
		if(!PurgeComm(hIRComm, PURGE_TXCLEAR | PURGE_RXCLEAR))
		{
			SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
						(LPARAM)(LPCTSTR)TEXT("Purge Comm Failed..\r\n"));

			UserCloseIR(hWnd);
			return;
		}
	}

	else	// ߴٸ  ޼ ǥ
	{
		SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
					(LPARAM)(LPCTSTR)TEXT("IRƮ  ߽ϴ.\r\n"));
	}

	//  ޼ .
	SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
			    (LPARAM)(LPCTSTR)TEXT("IR Port Open Complete!\r\n"));
}

// IR Ʈ ϴ Լ
void UserSendData(HWND hWnd, BYTE btCommand)
{
	extern HANDLE hIRComm;

	BYTE btTemp = btCommand;
	DWORD cBytes;
	TCHAR szMessage[100];

	// IR Ʈ ִ ˻!
	if(hIRComm == INVALID_HANDLE_VALUE)
	{
		SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
				    (LPARAM)(LPCTSTR)TEXT("IR Ʈ ֽϴ.\r\n"));
		return;
	}

	// IR Ʈ  
	if(!WriteFile(hIRComm, &btTemp, sizeof(BYTE), &cBytes, NULL))
	{
		// ۿ  ...
		SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
				    (LPARAM)(LPCTSTR)TEXT("IR Send Error!\r\n"));
		return;
	}

	// IR Ʈ   - ι͵ .
	btTemp = ~btTemp;
	if(!WriteFile(hIRComm, &btTemp, sizeof(BYTE), &cBytes, NULL))
	{
		// ۿ  ...
		SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
				    (LPARAM)(LPCTSTR)TEXT("IR Send Error!\r\n"));
		return;
	}

	// IR Ʈ   -  .
	btTemp = 0xFF;
	if(!WriteFile(hIRComm, &btTemp, sizeof(BYTE), &cBytes, NULL))
	{
		// ۿ  ...
		SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
				    (LPARAM)(LPCTSTR)TEXT("IR Send Error!\r\n"));
		return;
	}

	// Ϸ ޼ 
	wsprintf(szMessage, TEXT("۸ %02x ½ϴ.\r\n"), btCommand);

	MessageBeep(MB_OK);
	SendMessage(hStatusEdit, EM_REPLACESEL, 0, (LPARAM)szMessage);
}

// IR Ʈ Close ϴ Լ
void UserCloseIR(HWND hWnd)
{
	extern HANDLE hIRComm;

	// hIRComm ڵ ȿ ˻
	if(hIRComm == INVALID_HANDLE_VALUE)
	{
		SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
				    (LPARAM)(LPCTSTR)TEXT("Invalid Handle!\r\n"));
		return;
	}

	// Clear IR Share mode
#if defined(IR_SHARED)
	if(!EscapeCommFunction(hIRComm, CLRIR))
	{
		SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
				    (LPARAM)(LPCTSTR)TEXT("Clear IR Failed..\r\n"));
		return;
	}
#endif

	// Close Handle
	CloseHandle(hIRComm);
	hIRComm = INVALID_HANDLE_VALUE;

	//  ޼ .
	SendMessage(hStatusEdit, EM_REPLACESEL, 0, 
			    (LPARAM)(LPCTSTR)TEXT("IR Port Close Complete!\r\n"));
}
